
_set_up:

;code_Locking_V2.c,22 :: 		void set_up() {    //Configuration for Pic16F887
;code_Locking_V2.c,24 :: 		ANSEL = 0;//
	CLRF       ANSEL+0
;code_Locking_V2.c,25 :: 		ANSELH = 0;//  all the pins are configured as digital inputs or outpus
	CLRF       ANSELH+0
;code_Locking_V2.c,26 :: 		C1ON_bit = 0;   // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;code_Locking_V2.c,27 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;code_Locking_V2.c,28 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;code_Locking_V2.c,29 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;code_Locking_V2.c,30 :: 		TRISD0_bit=0;
	BCF        TRISD0_bit+0, BitPos(TRISD0_bit+0)
;code_Locking_V2.c,31 :: 		TRISD1_bit=0;
	BCF        TRISD1_bit+0, BitPos(TRISD1_bit+0)
;code_Locking_V2.c,32 :: 		RD0_bit=0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;code_Locking_V2.c,33 :: 		RD1_bit=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;code_Locking_V2.c,34 :: 		Keypad_Init();
	CALL       _Keypad_Init+0
;code_Locking_V2.c,35 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;code_Locking_V2.c,36 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;code_Locking_V2.c,37 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;code_Locking_V2.c,39 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_buzzer:

;code_Locking_V2.c,41 :: 		void buzzer() {
;code_Locking_V2.c,42 :: 		RD1_bit=1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;code_Locking_V2.c,43 :: 		delay_ms(Tone);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L_buzzer0:
	DECFSZ     R13+0, 1
	GOTO       L_buzzer0
	DECFSZ     R12+0, 1
	GOTO       L_buzzer0
;code_Locking_V2.c,44 :: 		RD1_bit=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;code_Locking_V2.c,45 :: 		delay_ms(Tone);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L_buzzer1:
	DECFSZ     R13+0, 1
	GOTO       L_buzzer1
	DECFSZ     R12+0, 1
	GOTO       L_buzzer1
;code_Locking_V2.c,46 :: 		}
L_end_buzzer:
	RETURN
; end of _buzzer

_loop:

;code_Locking_V2.c,48 :: 		void loop() {
;code_Locking_V2.c,49 :: 		text = "PASSWORD";
	MOVLW      ?lstr1_code_Locking_V2+0
	MOVWF      _text+0
;code_Locking_V2.c,50 :: 		Lcd_Out(1,4,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,51 :: 		text = "CORRECT";
	MOVLW      ?lstr2_code_Locking_V2+0
	MOVWF      _text+0
;code_Locking_V2.c,52 :: 		Lcd_Out(2,4,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,53 :: 		do {
L_loop2:
;code_Locking_V2.c,54 :: 		RD0_bit=1;
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
;code_Locking_V2.c,55 :: 		RD1_bit=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;code_Locking_V2.c,56 :: 		} while(1);
	GOTO       L_loop2
;code_Locking_V2.c,57 :: 		}
L_end_loop:
	RETURN
; end of _loop

_Get_password:

;code_Locking_V2.c,59 :: 		void Get_password() {
;code_Locking_V2.c,60 :: 		short int i=0, select=0, n=3, clr=0;
	CLRF       Get_password_i_L0+0
	CLRF       Get_password_select_L0+0
	MOVLW      3
	MOVWF      Get_password_n_L0+0
	CLRF       Get_password_clr_L0+0
;code_Locking_V2.c,63 :: 		for(i=0; i<=8; i++) {
	CLRF       Get_password_i_L0+0
L_Get_password5:
	MOVLW      128
	XORLW      8
	MOVWF      R0+0
	MOVLW      128
	XORWF      Get_password_i_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_Get_password6
;code_Locking_V2.c,64 :: 		text = "PASSWORD";
	MOVLW      ?lstr3_code_Locking_V2+0
	MOVWF      _text+0
;code_Locking_V2.c,65 :: 		Lcd_Out(1,4,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,66 :: 		if(aux==0) password = 10*password + contador;
	MOVF       _aux+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password8
	MOVLW      10
	MOVWF      R0+0
	CLRF       R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVF       _password+0, 0
	MOVWF      R4+0
	MOVF       _password+1, 0
	MOVWF      R4+1
	MOVF       _password+2, 0
	MOVWF      R4+2
	MOVF       _password+3, 0
	MOVWF      R4+3
	CALL       _Mul_32x32_U+0
	MOVF       _contador+0, 0
	MOVWF      _password+0
	MOVLW      0
	BTFSC      _password+0, 7
	MOVLW      255
	MOVWF      _password+1
	MOVWF      _password+2
	MOVWF      _password+3
	MOVF       R0+0, 0
	ADDWF      _password+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+1, 0
	ADDWF      _password+1, 1
	MOVF       R0+2, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+2, 0
	ADDWF      _password+2, 1
	MOVF       R0+3, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+3, 0
	ADDWF      _password+3, 1
L_Get_password8:
;code_Locking_V2.c,67 :: 		if(aux==1) password = password/10;
	MOVF       _aux+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password9
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _password+0, 0
	MOVWF      R0+0
	MOVF       _password+1, 0
	MOVWF      R0+1
	MOVF       _password+2, 0
	MOVWF      R0+2
	MOVF       _password+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _password+0
	MOVF       R0+1, 0
	MOVWF      _password+1
	MOVF       R0+2, 0
	MOVWF      _password+2
	MOVF       R0+3, 0
	MOVWF      _password+3
L_Get_password9:
;code_Locking_V2.c,68 :: 		if(aux==2) password = password;
	MOVF       _aux+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password10
L_Get_password10:
;code_Locking_V2.c,69 :: 		if(password>99999999) password=0;
	MOVLW      128
	XORLW      5
	MOVWF      R0+0
	MOVLW      128
	XORWF      _password+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Get_password54
	MOVF       _password+2, 0
	SUBLW      245
	BTFSS      STATUS+0, 2
	GOTO       L__Get_password54
	MOVF       _password+1, 0
	SUBLW      224
	BTFSS      STATUS+0, 2
	GOTO       L__Get_password54
	MOVF       _password+0, 0
	SUBLW      255
L__Get_password54:
	BTFSC      STATUS+0, 0
	GOTO       L_Get_password11
	CLRF       _password+0
	CLRF       _password+1
	CLRF       _password+2
	CLRF       _password+3
L_Get_password11:
;code_Locking_V2.c,70 :: 		if(password==0) {
	MOVLW      0
	MOVWF      R0+0
	XORWF      _password+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Get_password55
	MOVF       R0+0, 0
	XORWF      _password+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Get_password55
	MOVF       R0+0, 0
	XORWF      _password+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Get_password55
	MOVF       _password+0, 0
	XORLW      0
L__Get_password55:
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password12
;code_Locking_V2.c,71 :: 		Lcd_Chr(2,n,' ');
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       Get_password_n_L0+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      32
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;code_Locking_V2.c,72 :: 		n--;
	DECF       Get_password_n_L0+0, 1
;code_Locking_V2.c,73 :: 		}
	GOTO       L_Get_password13
L_Get_password12:
;code_Locking_V2.c,75 :: 		Lcd_Out(2,n,mess);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVF       Get_password_n_L0+0, 0
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       Get_password_mess_L0+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,76 :: 		Delay_ms(200);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_Get_password14:
	DECFSZ     R13+0, 1
	GOTO       L_Get_password14
	DECFSZ     R12+0, 1
	GOTO       L_Get_password14
	DECFSZ     R11+0, 1
	GOTO       L_Get_password14
	NOP
;code_Locking_V2.c,77 :: 		}
L_Get_password13:
;code_Locking_V2.c,78 :: 		do  //wait that the keypad is pressed and after that is free.
L_Get_password15:
;code_Locking_V2.c,79 :: 		kp=Keypad_Key_Click();  //read the keypad.
	CALL       _Keypad_Key_Click+0
	MOVF       R0+0, 0
	MOVWF      _kp+0
;code_Locking_V2.c,80 :: 		while (!kp);
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password15
;code_Locking_V2.c,81 :: 		switch (kp){
	GOTO       L_Get_password18
;code_Locking_V2.c,82 :: 		case  1: contador = 7; aux=0; n++; mess = "*";  buzzer(); break;  //7
L_Get_password20:
	MOVLW      7
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr4_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,83 :: 		case  2: contador = 8; aux=0; n++; mess = "*";  buzzer(); break;  //8
L_Get_password21:
	MOVLW      8
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr5_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,84 :: 		case  3: contador = 9; aux=0; n++; mess = "*";  buzzer(); break;  //9
L_Get_password22:
	MOVLW      9
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr6_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,85 :: 		case  4: contador = 0; aux=1; n--; mess = "* "; buzzer(); break; //(./.)
L_Get_password23:
	CLRF       _contador+0
	MOVLW      1
	MOVWF      _aux+0
	DECF       Get_password_n_L0+0, 1
	MOVLW      ?lstr7_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,86 :: 		case  5: contador = 4; aux=0; n++; mess = "*";  buzzer(); break; //4
L_Get_password24:
	MOVLW      4
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr8_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,87 :: 		case  6: contador = 5; aux=0; n++; mess = "*";  buzzer(); break; //5
L_Get_password25:
	MOVLW      5
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr9_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,88 :: 		case  7: contador = 6; aux=0; n++; mess = "*";  buzzer(); break; //6
L_Get_password26:
	MOVLW      6
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr10_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,89 :: 		case  8: contador = 0; aux=0; i=0; mess = " ";  clr=1; buzzer(); break; //(X)
L_Get_password27:
	CLRF       _contador+0
	CLRF       _aux+0
	CLRF       Get_password_i_L0+0
	MOVLW      ?lstr11_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	MOVLW      1
	MOVWF      Get_password_clr_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,90 :: 		case  9: contador = 1; aux=0; n++; mess = "*";  buzzer();  break; //1
L_Get_password28:
	MOVLW      1
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr12_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,91 :: 		case 10: contador = 2; aux=0; n++; mess = "*";  buzzer();  break; //2
L_Get_password29:
	MOVLW      2
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr13_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,92 :: 		case 11: contador = 3; aux=0; n++; mess = "*";  buzzer();  break; //3
L_Get_password30:
	MOVLW      3
	MOVWF      _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr14_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,93 :: 		case 12: contador = 0; aux=2; buzzer();  break;  //
L_Get_password31:
	CLRF       _contador+0
	MOVLW      2
	MOVWF      _aux+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,94 :: 		case 13: contador = 0; aux=2; buzzer();  break;  //
L_Get_password32:
	CLRF       _contador+0
	MOVLW      2
	MOVWF      _aux+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,95 :: 		case 14: contador = 0; aux=0; n++;  mess = "*"; buzzer();  break; //0
L_Get_password33:
	CLRF       _contador+0
	CLRF       _aux+0
	INCF       Get_password_n_L0+0, 1
	MOVLW      ?lstr15_code_Locking_V2+0
	MOVWF      Get_password_mess_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,96 :: 		case 15: contador = 0; aux=0, select=1; buzzer(); break; //(=)
L_Get_password34:
	CLRF       _contador+0
	CLRF       _aux+0
	MOVLW      1
	MOVWF      Get_password_select_L0+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,97 :: 		case 16: contador = 0; aux=2; buzzer(); break; //
L_Get_password35:
	CLRF       _contador+0
	MOVLW      2
	MOVWF      _aux+0
	CALL       _buzzer+0
	GOTO       L_Get_password19
;code_Locking_V2.c,98 :: 		}
L_Get_password18:
	MOVF       _kp+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password20
	MOVF       _kp+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password21
	MOVF       _kp+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password22
	MOVF       _kp+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password23
	MOVF       _kp+0, 0
	XORLW      5
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password24
	MOVF       _kp+0, 0
	XORLW      6
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password25
	MOVF       _kp+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password26
	MOVF       _kp+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password27
	MOVF       _kp+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password28
	MOVF       _kp+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password29
	MOVF       _kp+0, 0
	XORLW      11
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password30
	MOVF       _kp+0, 0
	XORLW      12
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password31
	MOVF       _kp+0, 0
	XORLW      13
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password32
	MOVF       _kp+0, 0
	XORLW      14
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password33
	MOVF       _kp+0, 0
	XORLW      15
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password34
	MOVF       _kp+0, 0
	XORLW      16
	BTFSC      STATUS+0, 2
	GOTO       L_Get_password35
L_Get_password19:
;code_Locking_V2.c,99 :: 		kp=0;
	CLRF       _kp+0
;code_Locking_V2.c,100 :: 		if((select==0) && (i=8)) i=0;
	MOVF       Get_password_select_L0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password38
	MOVLW      8
	MOVWF      Get_password_i_L0+0
L__Get_password49:
	CLRF       Get_password_i_L0+0
L_Get_password38:
;code_Locking_V2.c,101 :: 		if(select==1) i=8, select=0;
	MOVF       Get_password_select_L0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password39
	MOVLW      8
	MOVWF      Get_password_i_L0+0
	CLRF       Get_password_select_L0+0
L_Get_password39:
;code_Locking_V2.c,102 :: 		if(clr==1) Lcd_Cmd(_LCD_CLEAR), password=0, n=3, clr=0;
	MOVF       Get_password_clr_L0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_Get_password40
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
	CLRF       _password+0
	CLRF       _password+1
	CLRF       _password+2
	CLRF       _password+3
	MOVLW      3
	MOVWF      Get_password_n_L0+0
	CLRF       Get_password_clr_L0+0
L_Get_password40:
;code_Locking_V2.c,103 :: 		if(n>16) n=4, password=0, Lcd_Cmd(_LCD_CLEAR);
	MOVLW      128
	XORLW      16
	MOVWF      R0+0
	MOVLW      128
	XORWF      Get_password_n_L0+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_Get_password41
	MOVLW      4
	MOVWF      Get_password_n_L0+0
	CLRF       _password+0
	CLRF       _password+1
	CLRF       _password+2
	CLRF       _password+3
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
L_Get_password41:
;code_Locking_V2.c,104 :: 		if(n<4) n=4;
	MOVLW      128
	XORWF      Get_password_n_L0+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      4
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_Get_password42
	MOVLW      4
	MOVWF      Get_password_n_L0+0
L_Get_password42:
;code_Locking_V2.c,63 :: 		for(i=0; i<=8; i++) {
	INCF       Get_password_i_L0+0, 1
;code_Locking_V2.c,105 :: 		}
	GOTO       L_Get_password5
L_Get_password6:
;code_Locking_V2.c,106 :: 		}
L_end_Get_password:
	RETURN
; end of _Get_password

_main:

;code_Locking_V2.c,107 :: 		void main() {
;code_Locking_V2.c,108 :: 		set_up();
	CALL       _set_up+0
;code_Locking_V2.c,109 :: 		buzzer();
	CALL       _buzzer+0
;code_Locking_V2.c,110 :: 		text = "PASSWORD";
	MOVLW      ?lstr16_code_Locking_V2+0
	MOVWF      _text+0
;code_Locking_V2.c,111 :: 		Lcd_Out(1,4,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,112 :: 		Get_password();
	CALL       _Get_password+0
;code_Locking_V2.c,113 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;code_Locking_V2.c,114 :: 		if(password==12481632) loop();
	MOVF       _password+3, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main57
	MOVF       _password+2, 0
	XORLW      190
	BTFSS      STATUS+0, 2
	GOTO       L__main57
	MOVF       _password+1, 0
	XORLW      116
	BTFSS      STATUS+0, 2
	GOTO       L__main57
	MOVF       _password+0, 0
	XORLW      96
L__main57:
	BTFSS      STATUS+0, 2
	GOTO       L_main43
	CALL       _loop+0
L_main43:
;code_Locking_V2.c,115 :: 		text = "PASSWORD";
	MOVLW      ?lstr17_code_Locking_V2+0
	MOVWF      _text+0
;code_Locking_V2.c,116 :: 		Lcd_Out(1,4,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,117 :: 		text = "INCORRECT";
	MOVLW      ?lstr18_code_Locking_V2+0
	MOVWF      _text+0
;code_Locking_V2.c,118 :: 		Lcd_Out(2,4,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;code_Locking_V2.c,119 :: 		do {
L_main44:
;code_Locking_V2.c,120 :: 		RD1_bit=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;code_Locking_V2.c,121 :: 		delay_ms(alarm);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main47:
	DECFSZ     R13+0, 1
	GOTO       L_main47
	DECFSZ     R12+0, 1
	GOTO       L_main47
	DECFSZ     R11+0, 1
	GOTO       L_main47
	NOP
	NOP
;code_Locking_V2.c,122 :: 		RD1_bit=1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;code_Locking_V2.c,123 :: 		delay_ms(alarm);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main48:
	DECFSZ     R13+0, 1
	GOTO       L_main48
	DECFSZ     R12+0, 1
	GOTO       L_main48
	DECFSZ     R11+0, 1
	GOTO       L_main48
	NOP
	NOP
;code_Locking_V2.c,124 :: 		} while(1);
	GOTO       L_main44
;code_Locking_V2.c,125 :: 		}// END.
L_end_main:
	GOTO       $+0
; end of _main
