
_set_up:

;Temperature_Controller_Keypad.c,25 :: 		void set_up() {    //Configuration for Pic16F887
;Temperature_Controller_Keypad.c,27 :: 		ANSEL = 0x0D;// RA0, RA2 and RA3 are configured as analog inputs
	MOVLW      13
	MOVWF      ANSEL+0
;Temperature_Controller_Keypad.c,28 :: 		ANSELH = 0;//the Rest of the pins are configured as digital inputs or outputs.
	CLRF       ANSELH+0
;Temperature_Controller_Keypad.c,29 :: 		TRISA = 0x0D;
	MOVLW      13
	MOVWF      TRISA+0
;Temperature_Controller_Keypad.c,30 :: 		ADCON1.F4 = 1;     // VREF+ = 1.5v.
	BSF        ADCON1+0, 4
;Temperature_Controller_Keypad.c,31 :: 		ADCON1.F5 = 1;    // VREF- = GND.
	BSF        ADCON1+0, 5
;Temperature_Controller_Keypad.c,32 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;Temperature_Controller_Keypad.c,33 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;Temperature_Controller_Keypad.c,34 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;Temperature_Controller_Keypad.c,35 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;Temperature_Controller_Keypad.c,36 :: 		TRISD0_bit=0;
	BCF        TRISD0_bit+0, BitPos(TRISD0_bit+0)
;Temperature_Controller_Keypad.c,37 :: 		TRISE0_bit=0;
	BCF        TRISE0_bit+0, BitPos(TRISE0_bit+0)
;Temperature_Controller_Keypad.c,38 :: 		TRISE1_bit=0;
	BCF        TRISE1_bit+0, BitPos(TRISE1_bit+0)
;Temperature_Controller_Keypad.c,39 :: 		TRISE2_bit=0;
	BCF        TRISE2_bit+0, BitPos(TRISE2_bit+0)
;Temperature_Controller_Keypad.c,40 :: 		RD0_bit=0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;Temperature_Controller_Keypad.c,41 :: 		RE0_bit=0;
	BCF        RE0_bit+0, BitPos(RE0_bit+0)
;Temperature_Controller_Keypad.c,42 :: 		RE1_bit=0;
	BCF        RE1_bit+0, BitPos(RE1_bit+0)
;Temperature_Controller_Keypad.c,43 :: 		RE2_bit=0;
	BCF        RE2_bit+0, BitPos(RE2_bit+0)
;Temperature_Controller_Keypad.c,44 :: 		Keypad_Init();
	CALL       _Keypad_Init+0
;Temperature_Controller_Keypad.c,45 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;Temperature_Controller_Keypad.c,46 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Temperature_Controller_Keypad.c,47 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Temperature_Controller_Keypad.c,48 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_buzzer:

;Temperature_Controller_Keypad.c,49 :: 		void buzzer() {
;Temperature_Controller_Keypad.c,50 :: 		RD0_bit=1;
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
;Temperature_Controller_Keypad.c,51 :: 		delay_ms(Tone);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L_buzzer0:
	DECFSZ     R13+0, 1
	GOTO       L_buzzer0
	DECFSZ     R12+0, 1
	GOTO       L_buzzer0
;Temperature_Controller_Keypad.c,52 :: 		RD0_bit=0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;Temperature_Controller_Keypad.c,53 :: 		delay_ms(Tone);
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L_buzzer1:
	DECFSZ     R13+0, 1
	GOTO       L_buzzer1
	DECFSZ     R12+0, 1
	GOTO       L_buzzer1
;Temperature_Controller_Keypad.c,54 :: 		}
L_end_buzzer:
	RETURN
; end of _buzzer

_Test:

;Temperature_Controller_Keypad.c,55 :: 		void Test() {    // check the working of heater and cooler
;Temperature_Controller_Keypad.c,57 :: 		buzzer();
	CALL       _buzzer+0
;Temperature_Controller_Keypad.c,58 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Temperature_Controller_Keypad.c,59 :: 		text = "TEST_HEATER";
	MOVLW      ?lstr1_Temperature_Controller_Keypad+0
	MOVWF      _text+0
;Temperature_Controller_Keypad.c,60 :: 		Lcd_Out(1,2,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,61 :: 		RE0_bit=1;
	BSF        RE0_bit+0, BitPos(RE0_bit+0)
;Temperature_Controller_Keypad.c,62 :: 		RE2_bit=0;
	BCF        RE2_bit+0, BitPos(RE2_bit+0)
;Temperature_Controller_Keypad.c,63 :: 		delay_ms(D);
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_Test2:
	DECFSZ     R13+0, 1
	GOTO       L_Test2
	DECFSZ     R12+0, 1
	GOTO       L_Test2
	DECFSZ     R11+0, 1
	GOTO       L_Test2
	NOP
	NOP
;Temperature_Controller_Keypad.c,64 :: 		text = "TEST_COOLER";
	MOVLW      ?lstr2_Temperature_Controller_Keypad+0
	MOVWF      _text+0
;Temperature_Controller_Keypad.c,65 :: 		Lcd_Out(1,2,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,66 :: 		RE0_bit=0;
	BCF        RE0_bit+0, BitPos(RE0_bit+0)
;Temperature_Controller_Keypad.c,67 :: 		RE2_bit=1;
	BSF        RE2_bit+0, BitPos(RE2_bit+0)
;Temperature_Controller_Keypad.c,68 :: 		delay_ms(D);
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_Test3:
	DECFSZ     R13+0, 1
	GOTO       L_Test3
	DECFSZ     R12+0, 1
	GOTO       L_Test3
	DECFSZ     R11+0, 1
	GOTO       L_Test3
	NOP
	NOP
;Temperature_Controller_Keypad.c,69 :: 		text = "TEST_HEATER";
	MOVLW      ?lstr3_Temperature_Controller_Keypad+0
	MOVWF      _text+0
;Temperature_Controller_Keypad.c,70 :: 		Lcd_Out(2,2,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,71 :: 		RE0_bit=1;
	BSF        RE0_bit+0, BitPos(RE0_bit+0)
;Temperature_Controller_Keypad.c,72 :: 		RE2_bit=1;
	BSF        RE2_bit+0, BitPos(RE2_bit+0)
;Temperature_Controller_Keypad.c,73 :: 		delay_ms(D);
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_Test4:
	DECFSZ     R13+0, 1
	GOTO       L_Test4
	DECFSZ     R12+0, 1
	GOTO       L_Test4
	DECFSZ     R11+0, 1
	GOTO       L_Test4
	NOP
	NOP
;Temperature_Controller_Keypad.c,74 :: 		text = "TEST_FINISHED";
	MOVLW      ?lstr4_Temperature_Controller_Keypad+0
	MOVWF      _text+0
;Temperature_Controller_Keypad.c,75 :: 		Lcd_Out(1,2,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,76 :: 		Lcd_Out(2,2,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,77 :: 		RE0_bit=0;
	BCF        RE0_bit+0, BitPos(RE0_bit+0)
;Temperature_Controller_Keypad.c,78 :: 		RE2_bit=0;
	BCF        RE2_bit+0, BitPos(RE2_bit+0)
;Temperature_Controller_Keypad.c,79 :: 		delay_ms(D);
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_Test5:
	DECFSZ     R13+0, 1
	GOTO       L_Test5
	DECFSZ     R12+0, 1
	GOTO       L_Test5
	DECFSZ     R11+0, 1
	GOTO       L_Test5
	NOP
	NOP
;Temperature_Controller_Keypad.c,80 :: 		buzzer();
	CALL       _buzzer+0
;Temperature_Controller_Keypad.c,81 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Temperature_Controller_Keypad.c,82 :: 		}
L_end_Test:
	RETURN
; end of _Test

_print_temperature:

;Temperature_Controller_Keypad.c,84 :: 		void print_temperature() {
;Temperature_Controller_Keypad.c,88 :: 		ch = temp1 / 100;
	MOVLW      100
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _temp1+0, 0
	MOVWF      R0+0
	MOVF       _temp1+1, 0
	MOVWF      R0+1
	MOVF       _temp1+2, 0
	MOVWF      R0+2
	MOVF       _temp1+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
;Temperature_Controller_Keypad.c,89 :: 		Lcd_Chr(1,8,48+ch);
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Temperature_Controller_Keypad.c,90 :: 		ch = (temp1 / 10 )% 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _temp1+0, 0
	MOVWF      R0+0
	MOVF       _temp1+1, 0
	MOVWF      R0+1
	MOVF       _temp1+2, 0
	MOVWF      R0+2
	MOVF       _temp1+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Temperature_Controller_Keypad.c,91 :: 		Lcd_Chr_CP(48+ch);
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;Temperature_Controller_Keypad.c,92 :: 		ch = temp1 % 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _temp1+0, 0
	MOVWF      R0+0
	MOVF       _temp1+1, 0
	MOVWF      R0+1
	MOVF       _temp1+2, 0
	MOVWF      R0+2
	MOVF       _temp1+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Temperature_Controller_Keypad.c,93 :: 		Lcd_Chr_CP(48+ch);
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;Temperature_Controller_Keypad.c,94 :: 		ch = temp2 / 100;
	MOVLW      100
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _temp2+0, 0
	MOVWF      R0+0
	MOVF       _temp2+1, 0
	MOVWF      R0+1
	MOVF       _temp2+2, 0
	MOVWF      R0+2
	MOVF       _temp2+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
;Temperature_Controller_Keypad.c,95 :: 		Lcd_Chr(2,8,48+ch);
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Temperature_Controller_Keypad.c,96 :: 		ch = (temp2 / 10 )% 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _temp2+0, 0
	MOVWF      R0+0
	MOVF       _temp2+1, 0
	MOVWF      R0+1
	MOVF       _temp2+2, 0
	MOVWF      R0+2
	MOVF       _temp2+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Temperature_Controller_Keypad.c,97 :: 		Lcd_Chr_CP(48+ch);
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;Temperature_Controller_Keypad.c,98 :: 		ch = temp2 % 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _temp2+0, 0
	MOVWF      R0+0
	MOVF       _temp2+1, 0
	MOVWF      R0+1
	MOVF       _temp2+2, 0
	MOVWF      R0+2
	MOVF       _temp2+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;Temperature_Controller_Keypad.c,99 :: 		Lcd_Chr_CP(48+ch);
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;Temperature_Controller_Keypad.c,100 :: 		text = "temp1:";
	MOVLW      ?lstr5_Temperature_Controller_Keypad+0
	MOVWF      _text+0
;Temperature_Controller_Keypad.c,101 :: 		Lcd_Out(1,2,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,102 :: 		text = "temp2:";
	MOVLW      ?lstr6_Temperature_Controller_Keypad+0
	MOVWF      _text+0
;Temperature_Controller_Keypad.c,103 :: 		Lcd_Out(2,2,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Temperature_Controller_Keypad.c,104 :: 		Lcd_Chr(1,11,223);   // Print degree character for Centigrades.
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      11
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      223
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Temperature_Controller_Keypad.c,105 :: 		Lcd_Chr(1,12,'C');
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      12
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      67
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Temperature_Controller_Keypad.c,106 :: 		Lcd_Chr(2,11,223);   // Print degree character for Centigrades.
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      11
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      223
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Temperature_Controller_Keypad.c,107 :: 		Lcd_Chr(2,12,'C');
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      12
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      67
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Temperature_Controller_Keypad.c,108 :: 		Delay_ms(300);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L_print_temperature6:
	DECFSZ     R13+0, 1
	GOTO       L_print_temperature6
	DECFSZ     R12+0, 1
	GOTO       L_print_temperature6
	DECFSZ     R11+0, 1
	GOTO       L_print_temperature6
;Temperature_Controller_Keypad.c,109 :: 		}
L_end_print_temperature:
	RETURN
; end of _print_temperature

_START:

;Temperature_Controller_Keypad.c,110 :: 		void START() {
;Temperature_Controller_Keypad.c,112 :: 		buzzer();
	CALL       _buzzer+0
;Temperature_Controller_Keypad.c,113 :: 		LOOP:
___START_LOOP:
;Temperature_Controller_Keypad.c,114 :: 		adc_rd = ADC_Read(0);
	CLRF       FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;Temperature_Controller_Keypad.c,115 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_START7:
	DECFSZ     R13+0, 1
	GOTO       L_START7
	DECFSZ     R12+0, 1
	GOTO       L_START7
	NOP
	NOP
;Temperature_Controller_Keypad.c,116 :: 		temp2 = (long)adc_rd * factor;
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVLW      150
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Mul_32x32_U+0
	MOVF       R0+0, 0
	MOVWF      _temp2+0
	MOVF       R0+1, 0
	MOVWF      _temp2+1
	MOVF       R0+2, 0
	MOVWF      _temp2+2
	MOVF       R0+3, 0
	MOVWF      _temp2+3
;Temperature_Controller_Keypad.c,117 :: 		temp2 = temp2 / 1023;
	MOVLW      255
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _temp2+0
	MOVF       R0+1, 0
	MOVWF      _temp2+1
	MOVF       R0+2, 0
	MOVWF      _temp2+2
	MOVF       R0+3, 0
	MOVWF      _temp2+3
;Temperature_Controller_Keypad.c,118 :: 		if(temp1>100) temp1=100;
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _temp1+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START49
	MOVF       _temp1+2, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__START49
	MOVF       _temp1+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__START49
	MOVF       _temp1+0, 0
	SUBLW      100
L__START49:
	BTFSC      STATUS+0, 0
	GOTO       L_START8
	MOVLW      100
	MOVWF      _temp1+0
	CLRF       _temp1+1
	CLRF       _temp1+2
	CLRF       _temp1+3
L_START8:
;Temperature_Controller_Keypad.c,119 :: 		if(temp1 > temp2)  RE0_bit=1, RE1_bit=0, RE2_bit=0;
	MOVLW      128
	XORWF      _temp2+3, 0
	MOVWF      R0+0
	MOVLW      128
	XORWF      _temp1+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START50
	MOVF       _temp1+2, 0
	SUBWF      _temp2+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START50
	MOVF       _temp1+1, 0
	SUBWF      _temp2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START50
	MOVF       _temp1+0, 0
	SUBWF      _temp2+0, 0
L__START50:
	BTFSC      STATUS+0, 0
	GOTO       L_START9
	BSF        RE0_bit+0, BitPos(RE0_bit+0)
	BCF        RE1_bit+0, BitPos(RE1_bit+0)
	BCF        RE2_bit+0, BitPos(RE2_bit+0)
L_START9:
;Temperature_Controller_Keypad.c,120 :: 		if(temp1 == temp2) RE0_bit=0, RE1_bit=1, RE2_bit=0;
	MOVF       _temp1+3, 0
	XORWF      _temp2+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START51
	MOVF       _temp1+2, 0
	XORWF      _temp2+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START51
	MOVF       _temp1+1, 0
	XORWF      _temp2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START51
	MOVF       _temp1+0, 0
	XORWF      _temp2+0, 0
L__START51:
	BTFSS      STATUS+0, 2
	GOTO       L_START10
	BCF        RE0_bit+0, BitPos(RE0_bit+0)
	BSF        RE1_bit+0, BitPos(RE1_bit+0)
	BCF        RE2_bit+0, BitPos(RE2_bit+0)
L_START10:
;Temperature_Controller_Keypad.c,121 :: 		if(temp1 < temp2)  RE0_bit=0, RE1_bit=0, RE2_bit=1;
	MOVLW      128
	XORWF      _temp1+3, 0
	MOVWF      R0+0
	MOVLW      128
	XORWF      _temp2+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START52
	MOVF       _temp2+2, 0
	SUBWF      _temp1+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START52
	MOVF       _temp2+1, 0
	SUBWF      _temp1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__START52
	MOVF       _temp2+0, 0
	SUBWF      _temp1+0, 0
L__START52:
	BTFSC      STATUS+0, 0
	GOTO       L_START11
	BCF        RE0_bit+0, BitPos(RE0_bit+0)
	BCF        RE1_bit+0, BitPos(RE1_bit+0)
	BSF        RE2_bit+0, BitPos(RE2_bit+0)
L_START11:
;Temperature_Controller_Keypad.c,122 :: 		print_temperature();
	CALL       _print_temperature+0
;Temperature_Controller_Keypad.c,123 :: 		goto LOOP;
	GOTO       ___START_LOOP
;Temperature_Controller_Keypad.c,124 :: 		}
L_end_START:
	RETURN
; end of _START

_main:

;Temperature_Controller_Keypad.c,126 :: 		void main() {
;Temperature_Controller_Keypad.c,127 :: 		set_up();
	CALL       _set_up+0
;Temperature_Controller_Keypad.c,128 :: 		buzzer();
	CALL       _buzzer+0
;Temperature_Controller_Keypad.c,129 :: 		while (1){
L_main12:
;Temperature_Controller_Keypad.c,130 :: 		adc_rd = ADC_Read(0);
	CLRF       FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;Temperature_Controller_Keypad.c,131 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_main14:
	DECFSZ     R13+0, 1
	GOTO       L_main14
	DECFSZ     R12+0, 1
	GOTO       L_main14
	NOP
	NOP
;Temperature_Controller_Keypad.c,132 :: 		temp2 = (long)adc_rd * factor;
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVLW      150
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Mul_32x32_U+0
	MOVF       R0+0, 0
	MOVWF      _temp2+0
	MOVF       R0+1, 0
	MOVWF      _temp2+1
	MOVF       R0+2, 0
	MOVWF      _temp2+2
	MOVF       R0+3, 0
	MOVWF      _temp2+3
;Temperature_Controller_Keypad.c,133 :: 		temp2 = temp2 / 1023;
	MOVLW      255
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _temp2+0
	MOVF       R0+1, 0
	MOVWF      _temp2+1
	MOVF       R0+2, 0
	MOVWF      _temp2+2
	MOVF       R0+3, 0
	MOVWF      _temp2+3
;Temperature_Controller_Keypad.c,134 :: 		if(aux==0) temp1 =(10*temp1) + contador;
	MOVF       _aux+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main15
	MOVLW      10
	MOVWF      R0+0
	CLRF       R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVF       _temp1+0, 0
	MOVWF      R4+0
	MOVF       _temp1+1, 0
	MOVWF      R4+1
	MOVF       _temp1+2, 0
	MOVWF      R4+2
	MOVF       _temp1+3, 0
	MOVWF      R4+3
	CALL       _Mul_32x32_U+0
	MOVF       _contador+0, 0
	MOVWF      _temp1+0
	MOVLW      0
	BTFSC      _temp1+0, 7
	MOVLW      255
	MOVWF      _temp1+1
	MOVWF      _temp1+2
	MOVWF      _temp1+3
	MOVF       R0+0, 0
	ADDWF      _temp1+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+1, 0
	ADDWF      _temp1+1, 1
	MOVF       R0+2, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+2, 0
	ADDWF      _temp1+2, 1
	MOVF       R0+3, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+3, 0
	ADDWF      _temp1+3, 1
L_main15:
;Temperature_Controller_Keypad.c,135 :: 		if(aux==1) temp1=temp1++;
	MOVF       _aux+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main16
	MOVF       _temp1+0, 0
	MOVWF      R0+0
	MOVF       _temp1+1, 0
	MOVWF      R0+1
	MOVF       _temp1+2, 0
	MOVWF      R0+2
	MOVF       _temp1+3, 0
	MOVWF      R0+3
	INCF       R0+0, 1
	BTFSC      STATUS+0, 2
	INCF       R0+1, 1
	BTFSC      STATUS+0, 2
	INCF       R0+2, 1
	BTFSC      STATUS+0, 2
	INCF       R0+3, 1
	MOVF       R0+0, 0
	MOVWF      _temp1+0
	MOVF       R0+1, 0
	MOVWF      _temp1+1
	MOVF       R0+2, 0
	MOVWF      _temp1+2
	MOVF       R0+3, 0
	MOVWF      _temp1+3
L_main16:
;Temperature_Controller_Keypad.c,136 :: 		if(aux==2) {
	MOVF       _aux+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main17
;Temperature_Controller_Keypad.c,137 :: 		if(temp1==0)  temp1=0;
	MOVLW      0
	MOVWF      R0+0
	XORWF      _temp1+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main54
	MOVF       R0+0, 0
	XORWF      _temp1+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main54
	MOVF       R0+0, 0
	XORWF      _temp1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main54
	MOVF       _temp1+0, 0
	XORLW      0
L__main54:
	BTFSS      STATUS+0, 2
	GOTO       L_main18
	CLRF       _temp1+0
	CLRF       _temp1+1
	CLRF       _temp1+2
	CLRF       _temp1+3
	GOTO       L_main19
L_main18:
;Temperature_Controller_Keypad.c,138 :: 		else temp1=temp1--;
	MOVLW      1
	SUBWF      _temp1+0, 1
	BTFSS      STATUS+0, 0
	SUBWF      _temp1+1, 1
	BTFSS      STATUS+0, 0
	SUBWF      _temp1+2, 1
	BTFSS      STATUS+0, 0
	SUBWF      _temp1+3, 1
L_main19:
;Temperature_Controller_Keypad.c,139 :: 		}
L_main17:
;Temperature_Controller_Keypad.c,140 :: 		if(aux==3) temp1=temp1;
	MOVF       _aux+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main20
L_main20:
;Temperature_Controller_Keypad.c,141 :: 		if(temp1>100) temp1=100;
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _temp1+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main55
	MOVF       _temp1+2, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main55
	MOVF       _temp1+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main55
	MOVF       _temp1+0, 0
	SUBLW      100
L__main55:
	BTFSC      STATUS+0, 0
	GOTO       L_main21
	MOVLW      100
	MOVWF      _temp1+0
	CLRF       _temp1+1
	CLRF       _temp1+2
	CLRF       _temp1+3
L_main21:
;Temperature_Controller_Keypad.c,142 :: 		print_temperature();
	CALL       _print_temperature+0
;Temperature_Controller_Keypad.c,143 :: 		do //hope that the keypad is pressed and after thar is free.
L_main22:
;Temperature_Controller_Keypad.c,144 :: 		kp=Keypad_Key_Click();  //read the keypad.
	CALL       _Keypad_Key_Click+0
	MOVF       R0+0, 0
	MOVWF      _kp+0
;Temperature_Controller_Keypad.c,145 :: 		while (!kp);
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main22
;Temperature_Controller_Keypad.c,146 :: 		switch (kp){
	GOTO       L_main25
;Temperature_Controller_Keypad.c,147 :: 		case  1: contador = 7; aux=0; buzzer(); break; // 7
L_main27:
	MOVLW      7
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,148 :: 		case  2: contador = 8; aux=0; buzzer(); break; // 8
L_main28:
	MOVLW      8
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,149 :: 		case  3: contador = 9; aux=0; buzzer(); break; // 9
L_main29:
	MOVLW      9
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,150 :: 		case  4: contador = 0; aux=3; buzzer(); break; //watch the real value of temp2
L_main30:
	CLRF       _contador+0
	MOVLW      3
	MOVWF      _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,151 :: 		case  5: contador = 4; aux=0; buzzer(); break; // 4
L_main31:
	MOVLW      4
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,152 :: 		case  6: contador = 5; aux=0; buzzer(); break; // 5
L_main32:
	MOVLW      5
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,153 :: 		case  7: contador = 6; aux=0; buzzer(); break; // 6
L_main33:
	MOVLW      6
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,154 :: 		case  8: contador = 0; aux=0; temp1=0;  buzzer(); break; // X clear
L_main34:
	CLRF       _contador+0
	CLRF       _aux+0
	CLRF       _temp1+0
	CLRF       _temp1+1
	CLRF       _temp1+2
	CLRF       _temp1+3
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,155 :: 		case  9: contador = 1; aux=0; buzzer(); break; // 1
L_main35:
	MOVLW      1
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,156 :: 		case 10: contador = 2; aux=0; buzzer(); break; // 2
L_main36:
	MOVLW      2
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,157 :: 		case 11: contador = 3; aux=0; buzzer(); break; // 3
L_main37:
	MOVLW      3
	MOVWF      _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,158 :: 		case 12: contador = 0; aux=2; buzzer(); break; //temp1-1(-)
L_main38:
	CLRF       _contador+0
	MOVLW      2
	MOVWF      _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,159 :: 		case 13: contador = 0; aux=3; Test();   break; // checking heater and cooler
L_main39:
	CLRF       _contador+0
	MOVLW      3
	MOVWF      _aux+0
	CALL       _Test+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,160 :: 		case 14: contador = 0; aux=0; buzzer(); break; // 0
L_main40:
	CLRF       _contador+0
	CLRF       _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,161 :: 		case 15: contador = 0; aux=0; START();  break; //(=)START
L_main41:
	CLRF       _contador+0
	CLRF       _aux+0
	CALL       _START+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,162 :: 		case 16: contador = 0; aux=1; buzzer(); break; //temp1+1(+)
L_main42:
	CLRF       _contador+0
	MOVLW      1
	MOVWF      _aux+0
	CALL       _buzzer+0
	GOTO       L_main26
;Temperature_Controller_Keypad.c,163 :: 		}
L_main25:
	MOVF       _kp+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_main27
	MOVF       _kp+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_main28
	MOVF       _kp+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_main29
	MOVF       _kp+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_main30
	MOVF       _kp+0, 0
	XORLW      5
	BTFSC      STATUS+0, 2
	GOTO       L_main31
	MOVF       _kp+0, 0
	XORLW      6
	BTFSC      STATUS+0, 2
	GOTO       L_main32
	MOVF       _kp+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L_main33
	MOVF       _kp+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L_main34
	MOVF       _kp+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L_main35
	MOVF       _kp+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_main36
	MOVF       _kp+0, 0
	XORLW      11
	BTFSC      STATUS+0, 2
	GOTO       L_main37
	MOVF       _kp+0, 0
	XORLW      12
	BTFSC      STATUS+0, 2
	GOTO       L_main38
	MOVF       _kp+0, 0
	XORLW      13
	BTFSC      STATUS+0, 2
	GOTO       L_main39
	MOVF       _kp+0, 0
	XORLW      14
	BTFSC      STATUS+0, 2
	GOTO       L_main40
	MOVF       _kp+0, 0
	XORLW      15
	BTFSC      STATUS+0, 2
	GOTO       L_main41
	MOVF       _kp+0, 0
	XORLW      16
	BTFSC      STATUS+0, 2
	GOTO       L_main42
L_main26:
;Temperature_Controller_Keypad.c,164 :: 		}
	GOTO       L_main12
;Temperature_Controller_Keypad.c,166 :: 		Delay_ms(10);
L_main43:
	DECFSZ     R13+0, 1
	GOTO       L_main43
	DECFSZ     R12+0, 1
	GOTO       L_main43
	NOP
	NOP
;Temperature_Controller_Keypad.c,167 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
