#line 1 "C:/Users/Usuario/Documents/MikroC_programas/Temperature_Controller_Keypad/Temperature_Controller_Keypad.c"

char keypadPort at PORTB;



sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;

unsigned int adc_rd;
int short aux=0, contador=0;
char *text, kp=0;
long temp1=0, temp2=0;
const int factor=150;

void set_up() {

 ANSEL = 0x0D;
 ANSELH = 0;
 TRISA = 0x0D;
 ADCON1.F4 = 1;
 ADCON1.F5 = 1;
 C1ON_bit = 0;
 C2ON_bit = 0;
 CCP1CON = 0;
 CCP2CON = 0;
 TRISD0_bit=0;
 TRISE0_bit=0;
 TRISE1_bit=0;
 TRISE2_bit=0;
 RD0_bit=0;
 RE0_bit=0;
 RE1_bit=0;
 RE2_bit=0;
 Keypad_Init();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
}
void buzzer() {
 RD0_bit=1;
 delay_ms( 150 );
 RD0_bit=0;
 delay_ms( 150 );
}
void Test() {

 buzzer();
 Lcd_Cmd(_LCD_CLEAR);
 text = "TEST_HEATER";
 Lcd_Out(1,2,text);
 RE0_bit=1;
 RE2_bit=0;
 delay_ms( 3000 );
 text = "TEST_COOLER";
 Lcd_Out(1,2,text);
 RE0_bit=0;
 RE2_bit=1;
 delay_ms( 3000 );
 text = "TEST_HEATER";
 Lcd_Out(2,2,text);
 RE0_bit=1;
 RE2_bit=1;
 delay_ms( 3000 );
 text = "TEST_FINISHED";
 Lcd_Out(1,2,text);
 Lcd_Out(2,2,text);
 RE0_bit=0;
 RE2_bit=0;
 delay_ms( 3000 );
 buzzer();
 Lcd_Cmd(_LCD_CLEAR);
}

void print_temperature() {

 unsigned char ch ;

 ch = temp1 / 100;
 Lcd_Chr(1,8,48+ch);
 ch = (temp1 / 10 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = temp1 % 10;
 Lcd_Chr_CP(48+ch);
 ch = temp2 / 100;
 Lcd_Chr(2,8,48+ch);
 ch = (temp2 / 10 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = temp2 % 10;
 Lcd_Chr_CP(48+ch);
 text = "temp1:";
 Lcd_Out(1,2,text);
 text = "temp2:";
 Lcd_Out(2,2,text);
 Lcd_Chr(1,11,223);
 Lcd_Chr(1,12,'C');
 Lcd_Chr(2,11,223);
 Lcd_Chr(2,12,'C');
 Delay_ms(300);
}
void START() {

 buzzer();
 LOOP:
 adc_rd = ADC_Read(0);
 delay_ms(2);
 temp2 = (long)adc_rd * factor;
 temp2 = temp2 / 1023;
 if(temp1>100) temp1=100;
 if(temp1 > temp2) RE0_bit=1, RE1_bit=0, RE2_bit=0;
 if(temp1 == temp2) RE0_bit=0, RE1_bit=1, RE2_bit=0;
 if(temp1 < temp2) RE0_bit=0, RE1_bit=0, RE2_bit=1;
 print_temperature();
 goto LOOP;
}

void main() {
 set_up();
 buzzer();
 while (1){
 adc_rd = ADC_Read(0);
 delay_ms(2);
 temp2 = (long)adc_rd * factor;
 temp2 = temp2 / 1023;
 if(aux==0) temp1 =(10*temp1) + contador;
 if(aux==1) temp1=temp1++;
 if(aux==2) {
 if(temp1==0) temp1=0;
 else temp1=temp1--;
 }
 if(aux==3) temp1=temp1;
 if(temp1>100) temp1=100;
 print_temperature();
 do
 kp=Keypad_Key_Click();
 while (!kp);
 switch (kp){
 case 1: contador = 7; aux=0; buzzer(); break;
 case 2: contador = 8; aux=0; buzzer(); break;
 case 3: contador = 9; aux=0; buzzer(); break;
 case 4: contador = 0; aux=3; buzzer(); break;
 case 5: contador = 4; aux=0; buzzer(); break;
 case 6: contador = 5; aux=0; buzzer(); break;
 case 7: contador = 6; aux=0; buzzer(); break;
 case 8: contador = 0; aux=0; temp1=0; buzzer(); break;
 case 9: contador = 1; aux=0; buzzer(); break;
 case 10: contador = 2; aux=0; buzzer(); break;
 case 11: contador = 3; aux=0; buzzer(); break;
 case 12: contador = 0; aux=2; buzzer(); break;
 case 13: contador = 0; aux=3; Test(); break;
 case 14: contador = 0; aux=0; buzzer(); break;
 case 15: contador = 0; aux=0; START(); break;
 case 16: contador = 0; aux=1; buzzer(); break;
 }
 }
 kp=0;
 Delay_ms(10);
 }
